import PrimitiveRenderer from "./PrimitiveRenderer.js";

export default class PlaneRenderer extends PrimitiveRenderer {
    constructor(length=1, width=1, color=[1, 1, 1, 1]) {
        super();
        this.initShape(length, width, color);
    }

    initShape(length, width, color) {
        // set up all corner points
        this.vertices = [
            -length / 2, 0, -width / 2,
            -length / 2, 0, width / 2,
            length / 2, 0, width / 2,
            length / 2, 0, -width / 2,
        ];
        
        // build two tris in CCW order
        this.indices = [
            0, 2, 1,
            0, 3, 2
        ];

        // assign the color to all vertices
        this.colors = [
            ...color,
            ...color,
            ...color,
            ...color
        ];
    }
}